##############################################
#           DRAG AND DROP PLUGIN             #
##############################################
#     Author: MeV (chrystalyst@free.fr)      #
##############################################

namespace eval ::dnd {
variable window

############################
# ::dnd::InitPlugin dir    #
# -------------------------#
# Load proc of DnD Plugin  #
############################

proc InitPlugin { dir } {
	tkdndLoad $dir
	::plugins::RegisterPlugin "Drag and Drop"
	::plugins::RegisterEvent "Drag and Drop" chatsendbutton RegisterDND
}


##########################
# ::dnd::tkdndLoad dir   #
# -----------------------#
# Load the tkdnd Library #
##########################
proc tkdndLoad {dir} {
	load [file join $dir tkdnd libtkdnd[info sharedlibextension]]
	source [file join $dir tkdnd tkDND_Utils.tcl]
}

###############################################################
# ::dnd::RegisterDND event epvar                              #
# ------------------------------------------------------------#
# Register the Input text widget in chat window as DND target #
###############################################################

proc RegisterDND {event epvar} {
	upvar 2 $epvar args
	set ::dnd::window $args(window_name)
	dnd bindtarget [::ChatWindow::GetInputText $::dnd::window] Files <Drop> {::dnd::HandleFileDrop $::dnd::window %D}
	dnd bindtarget [::ChatWindow::GetInputText $::dnd::window] UniformResourceLocator <Drop> {%W insert end %D}
	dnd bindtarget [::ChatWindow::GetInputText $::dnd::window] Text <Drop> {%W insert end %D}
}

###############################################################
# ::dnd::HandleFileDrop window data                           #
# ------------------------------------------------------------#
# Proc called when a file is dropped to the input text widget #
###############################################################

proc HandleFileDrop {window data} {
	global tcl_platform
	#Send the name of the file to the ::amsn::FileTransferSend proc (for windows $data is like this "{filename}")
	if {$tcl_platform(platform) == "windows"} {
        ::amsn::FileTransferSend $window [string range $data 1 [expr [string length $data] - 2]]
	} else {
        ::amsn::FileTransferSend $window [string range $data 5 [expr [string length $data] - 1]]
	}
}

}